 
runHmmld.ped<-function(pedfile_object,pair=c(1,2),par=NULL,min.maf=0,LD="rsq2",epsilon=0.01,back=5,alim=c(0.001,0.15),start=NULL,prune=NULL,ld_adj=TRUE,fix.a=NULL,fix.k2=NULL,calc.a=FALSE,phi=0.013,timesToRun=10,timesToConverge=5,giveCrap=FALSE,convTol=0.1){

#to keep datastructures in c/c++ we'll check the folliwin in the c/c++ code
#matrixdims, position/chromosome lengths vs genotypes, pairs to run analayss on should be within the genotypes dims.

  if(length(pair)!=2)
    stop("pair must contain the number of two individuals")

  if(pair[1]==pair[2])
    stop("pair must be two different individuals")
  if(any(pair<1))
    stop("pair must be a positive integer")

  
  if(min.maf<0|min.maf>=1)
    stop("min.maf must have a value between 0 and 1")

  if(!LD%in%c("rsq2","D","D'"))
    stop("LD must be either \"rsq2\",\"D\" og \"D'\"")

  if(epsilon<0|epsilon>=1)
    stop("epsilon must have a value between 0 and 1")


  #check fixA
  fixA <- c()
  if(is.null(fix.a))
    fixA <- NULL
  else
    fixA <- as.real(fix.a)
  
  #check fixK
   fixK <- c()
  if(is.null(fix.k2))
    fixK <- NULL
  else
    fixK <- as.real(fix.k2)

  #check prune
  if(!is.null(prune)){
    if(prune==0)
      prune<-NULL
    else
      prune <- as.real(prune)
  }

  #point likelihood
  pa <- c()
  if(is.null(par))
    pa <- NULL
  else
    pa <- as.real(par)

  myphi <- c()
  if(is.null(phi))
    myphi <- NULL
  else
    myphi <- as.real(phi)

  #these are not used by the user
  #maf
  moment=FALSE
  double_recom=FALSE
  maf=NULL
  method=NULL
  optim=1
  LD_var <- ifelse(LD=="rsq2",TRUE,FALSE)
  res<-.Call("interface2",pedfile_object,as.integer(pair),pa,as.numeric(min.maf),as.integer(double_recom),as.integer(LD_var),as.numeric(epsilon),as.numeric(back),as.numeric(alim),as.integer(optim),as.numeric(start),prune,as.integer(ld_adj),fixA,fixK,as.integer(moment),calc.a,myphi,as.integer(timesToRun),as.integer(timesToConverge),as.integer(giveCrap),as.numeric(convTol),PACKAGE="Relate")
  
  names(res$kResult)<-c("IBD=2","IBD=1","IBD=0")

  class(res)<-"HMMrelate"
  return(res)
}
 
